Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 4901)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1)
@@ -433,569 +177,201 @@
     DO  ii = 1, doav_n
 
-       trimvar = TRIM( doav(ii) )
 !
 !--    Store the array chosen on the temporary array.
-       SELECT CASE ( trimvar )
-
-          CASE ( 'ghf*' )
-             IF ( ALLOCATED( ghf_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-!
-!--                   Check whether grid point is a natural- or urban-type surface.
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-!
-!--                   In order to avoid double-counting of surface properties, always assume that
-!--                   natural-type surfaces are below urban type surfaces, e.g. in case of bridges.
-!--                   Further, take only the last suface element, i.e. the uppermost surface which
-!--                   would be visible from above
-                      IF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         ghf_av(j,i) = ghf_av(j,i) + surf_lsm_h(0)%ghf(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         ghf_av(j,i) = ghf_av(j,i) + surf_usm_h(0)%frac(m,ind_veg_wall)  *            &
-                                                     surf_usm_h(0)%wghf_eb(m)        +                &
-                                                     surf_usm_h(0)%frac(m,ind_pav_green) *            &
-                                                     surf_usm_h(0)%wghf_eb_green(m)  +                &
-                                                     surf_usm_h(0)%frac(m,ind_wat_win)   *            &
-                                                     surf_usm_h(0)%wghf_eb_window(m)
+       SELECT CASE ( TRIM( doav(ii) ) )
+
+          CASE ( 'e' )
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      e_av(k,j,i) = e_av(k,j,i) + e(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'lwp*' )
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   lwp_av(j,i) = lwp_av(j,i) + SUM( ql(nzb:nzt,j,i) * &
+                                                    dzw(1:nzt+1) )
+                ENDDO
+             ENDDO
+
+          CASE ( 'p' )
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      p_av(k,j,i) = p_av(k,j,i) + p(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'pc' )
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb, nzt+1
+                      pc_av(k,j,i) = pc_av(k,j,i) + prt_count(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'pr' )
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
+                   DO  k = nzb, nzt+1
+                      psi = prt_start_index(k,j,i)
+                      s_r3 = 0.0
+                      s_r4 = 0.0
+                      DO  n = psi, psi+prt_count(k,j,i)-1
+                         s_r3 = s_r3 + particles(n)%radius**3
+                         s_r4 = s_r4 + particles(n)%radius**4
+                      ENDDO
+                      IF ( s_r3 /= 0.0 )  THEN
+                         mean_r = s_r4 / s_r3
+                      ELSE
+                         mean_r = 0.0
                       ENDIF
+                      pr_av(k,j,i) = pr_av(k,j,i) + mean_r
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'pt' )
+             IF ( .NOT. cloud_physics ) THEN
+                DO  i = nxl-1, nxr+1
+                   DO  j = nys-1, nyn+1
+                      DO  k = nzb, nzt+1
+                         pt_av(k,j,i) = pt_av(k,j,i) + pt(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                DO  i = nxl-1, nxr+1
+                   DO  j = nys-1, nyn+1
+                      DO  k = nzb, nzt+1
+                         pt_av(k,j,i) = pt_av(k,j,i) + pt(k,j,i) + l_d_cp * &
+                                                       pt_d_t(k) * ql(k,j,i)
+                      ENDDO
                    ENDDO
                 ENDDO
              ENDIF
 
-          CASE ( 'e' )
-             IF ( ALLOCATED( e_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         e_av(k,j,i) = e_av(k,j,i) + e(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'thetal' )
-             IF ( ALLOCATED( lpt_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         lpt_av(k,j,i) = lpt_av(k,j,i) + pt(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'lwp*' )
-             IF ( ALLOCATED( lwp_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      lwp_av(j,i) = lwp_av(j,i) + SUM( ql(nzb:nzt,j,i) * dzw(1:nzt+1) )            &
-                                                                       * rho_surface
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'ol*' )
-             IF ( ALLOCATED( ol_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         ol_av(j,i) = ol_av(j,i) + surf_def_h(0)%ol(m)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         ol_av(j,i) = ol_av(j,i) + surf_lsm_h(0)%ol(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         ol_av(j,i) = ol_av(j,i) + surf_usm_h(0)%ol(m)
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'p' )
-             IF ( ALLOCATED( p_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         p_av(k,j,i) = p_av(k,j,i) + p(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'pc' )
-             IF ( ALLOCATED( pc_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      DO  k = nzb, nzt+1
-                         pc_av(k,j,i) = pc_av(k,j,i) + prt_count(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'pr' )
-             IF ( ALLOCATED( pr_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      DO  k = nzb, nzt+1
-                         number_of_particles = prt_count(k,j,i)
-                         IF ( number_of_particles <= 0 )  CYCLE
-                         particles => grid_particles(k,j,i)%particles(1:number_of_particles)
-                         s_r2 = 0.0_wp
-                         s_r3 = 0.0_wp
-
-                         DO  n = 1, number_of_particles
-                            IF ( particles(n)%particle_mask )  THEN
-                               s_r2 = s_r2 + particles(n)%radius**2 * particles(n)%weight_factor
-                               s_r3 = s_r3 + particles(n)%radius**3 * particles(n)%weight_factor
-                            ENDIF
-                         ENDDO
-
-                         IF ( s_r2 > 0.0_wp )  THEN
-                            mean_r = s_r3 / s_r2
-                         ELSE
-                            mean_r = 0.0_wp
-                         ENDIF
-                         pr_av(k,j,i) = pr_av(k,j,i) + mean_r
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'theta' )
-             IF ( ALLOCATED( pt_av ) ) THEN
-                IF ( .NOT. bulk_cloud_model ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                            pt_av(k,j,i) = pt_av(k,j,i) + pt(k,j,i)
-                         ENDDO
-                      ENDDO
-                   ENDDO
-                ELSE
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                            pt_av(k,j,i) = pt_av(k,j,i) + pt(k,j,i) + lv_d_cp * d_exner(k)         &
-                                                                              * ql(k,j,i)
-                         ENDDO
-                      ENDDO
-                   ENDDO
-                ENDIF
-             ENDIF
-
           CASE ( 'q' )
-             IF ( ALLOCATED( q_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         q_av(k,j,i) = q_av(k,j,i) + q(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      q_av(k,j,i) = q_av(k,j,i) + q(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+             
           CASE ( 'ql' )
-             IF ( ALLOCATED( ql_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         ql_av(k,j,i) = ql_av(k,j,i) + ql(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      ql_av(k,j,i) = ql_av(k,j,i) + ql(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'ql_c' )
-             IF ( ALLOCATED( ql_c_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         ql_c_av(k,j,i) = ql_c_av(k,j,i) + ql_c(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      ql_c_av(k,j,i) = ql_c_av(k,j,i) + ql_c(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'ql_v' )
-             IF ( ALLOCATED( ql_v_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         ql_v_av(k,j,i) = ql_v_av(k,j,i) + ql_v(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      ql_v_av(k,j,i) = ql_v_av(k,j,i) + ql_v(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'ql_vp' )
-             IF ( ALLOCATED( ql_vp_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      DO  k = nzb, nzt+1
-                         number_of_particles = prt_count(k,j,i)
-                         IF ( number_of_particles <= 0 )  CYCLE
-                         particles => grid_particles(k,j,i)%particles(1:number_of_particles)
-                         DO  n = 1, number_of_particles
-                            IF ( particles(n)%particle_mask )  THEN
-                               ql_vp_av(k,j,i) = ql_vp_av(k,j,i) +                                 &
-                                                 particles(n)%weight_factor / number_of_particles
-                            ENDIF
-                         ENDDO
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'qsurf*' )
-             IF ( ALLOCATED( qsurf_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         qsurf_av(j,i) = qsurf_av(j,i) + surf_def_h(0)%q_surface(m)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         qsurf_av(j,i) = qsurf_av(j,i) + surf_lsm_h(0)%q_surface(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         qsurf_av(j,i) = qsurf_av(j,i) + surf_usm_h(0)%q_surface(m)
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'qsws*' )
-!
-!--          In case of default surfaces, clean-up flux by density.
-!--          In case of land- and urban-surfaces, convert fluxes into dynamic units.
-!--          Question (maronga): are the .NOT. statements really required?
-             IF ( ALLOCATED( qsws_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         qsws_av(j,i) = qsws_av(j,i) + surf_def_h(0)%qsws(m) *                     &
-                                        waterflux_output_conversion(nzb)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         qsws_av(j,i) = qsws_av(j,i) + surf_lsm_h(0)%qsws(m) * l_v
-                      ELSEIF ( match_usm  .AND.  .NOT. match_lsm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         qsws_av(j,i) = qsws_av(j,i) + surf_usm_h(0)%qsws(m) * l_v
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      ql_vp_av(k,j,i) = ql_vp_av(k,j,i) + ql_vp(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'qv' )
-             IF ( ALLOCATED( qv_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         qv_av(k,j,i) = qv_av(k,j,i) + q(k,j,i) - ql(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'r_a*' )
-             IF ( ALLOCATED( r_a_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         r_a_av(j,i) = r_a_av(j,i) + surf_lsm_h(0)%r_a(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         r_a_av(j,i) = r_a_av(j,i) + surf_usm_h(0)%frac(m,ind_veg_wall)  *            &
-                                                     surf_usm_h(0)%r_a(m)       +                     &
-                                                     surf_usm_h(0)%frac(m,ind_pav_green) *            &
-                                                     surf_usm_h(0)%r_a_green(m) +                     &
-                                                     surf_usm_h(0)%frac(m,ind_wat_win)   *            &
-                                                     surf_usm_h(0)%r_a_window(m)
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      qv_av(k,j,i) = qv_av(k,j,i) + q(k,j,i) - ql(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 's' )
-             IF ( ALLOCATED( s_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         s_av(k,j,i) = s_av(k,j,i) + s(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'shf*' )
-!
-!--          In case of default surfaces, clean-up flux by density.
-!--          In case of land- and urban-surfaces, convert fluxes into dynamic units.
-             IF ( ALLOCATED( shf_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         shf_av(j,i) = shf_av(j,i) + surf_def_h(0)%shf(m)  *                       &
-                                       heatflux_output_conversion(nzb)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         shf_av(j,i) = shf_av(j,i) + surf_lsm_h(0)%shf(m) * c_p
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         shf_av(j,i) = shf_av(j,i) + surf_usm_h(0)%shf(m) * c_p
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'ssurf*' )
-             IF ( ALLOCATED( ssurf_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      k = topo_top_ind(j,i,0)
-                      ssurf_av(j,i) = ssurf_av(j,i) + s(k,j,i)
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'ssws*' )
-             IF ( ALLOCATED( ssws_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         ssws_av(j,i) = ssws_av(j,i) + surf_def_h(0)%ssws(m)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         ssws_av(j,i) = ssws_av(j,i) + surf_lsm_h(0)%ssws(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         ssws_av(j,i) = ssws_av(j,i) + surf_usm_h(0)%ssws(m)
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
-
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      s_av(k,j,i) = s_av(k,j,i) + q(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+             
           CASE ( 't*' )
-             IF ( ALLOCATED( ts_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         ts_av(j,i) = ts_av(j,i) + surf_def_h(0)%ts(m)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         ts_av(j,i) = ts_av(j,i) + surf_lsm_h(0)%ts(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         ts_av(j,i) = ts_av(j,i) + surf_usm_h(0)%ts(m)
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'tsurf*' )
-             IF ( ALLOCATED( tsurf_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         tsurf_av(j,i) = tsurf_av(j,i) + surf_def_h(0)%pt_surface(m)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         tsurf_av(j,i) = tsurf_av(j,i) + surf_lsm_h(0)%pt_surface(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         tsurf_av(j,i) = tsurf_av(j,i) + surf_usm_h(0)%pt_surface(m)
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   ts_av(j,i) = ts_av(j,i) + ts(j,i)
+                ENDDO
+             ENDDO
 
           CASE ( 'u' )
-             IF ( ALLOCATED( u_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         u_av(k,j,i) = u_av(k,j,i) + u(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'us*' )
-             IF ( ALLOCATED( us_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         us_av(j,i) = us_av(j,i) + surf_def_h(0)%us(m)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         us_av(j,i) = us_av(j,i) + surf_lsm_h(0)%us(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         us_av(j,i) = us_av(j,i) + surf_usm_h(0)%us(m)
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      u_av(k,j,i) = u_av(k,j,i) + u(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'u*' )
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   us_av(j,i) = us_av(j,i) + us(j,i)
+                ENDDO
+             ENDDO
 
           CASE ( 'v' )
-             IF ( ALLOCATED( v_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         v_av(k,j,i) = v_av(k,j,i) + v(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'thetav' )
-             IF ( ALLOCATED( vpt_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         vpt_av(k,j,i) = vpt_av(k,j,i) + vpt(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      v_av(k,j,i) = v_av(k,j,i) + v(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
+
+          CASE ( 'vpt' )
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      vpt_av(k,j,i) = vpt_av(k,j,i) + vpt(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE ( 'w' )
-             IF ( ALLOCATED( w_av ) ) THEN
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         w_av(k,j,i) = w_av(k,j,i) + w(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'z0*' )
-             IF ( ALLOCATED( z0_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         z0_av(j,i) = z0_av(j,i) + surf_def_h(0)%z0(m)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         z0_av(j,i) = z0_av(j,i) + surf_lsm_h(0)%z0(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         z0_av(j,i) = z0_av(j,i) + surf_usm_h(0)%z0(m)
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'z0h*' )
-             IF ( ALLOCATED( z0h_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         z0h_av(j,i) = z0h_av(j,i) + surf_def_h(0)%z0h(m)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         z0h_av(j,i) = z0h_av(j,i) + surf_lsm_h(0)%z0h(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         z0h_av(j,i) = z0h_av(j,i) + surf_usm_h(0)%z0h(m)
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'z0q*' )
-             IF ( ALLOCATED( z0q_av ) ) THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
-                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
-
-                      IF ( match_def )  THEN
-                         m = surf_def_h(0)%end_index(j,i)
-                         z0q_av(j,i) = z0q_av(j,i) + surf_def_h(0)%z0q(m)
-                      ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h(0)%end_index(j,i)
-                         z0q_av(j,i) = z0q_av(j,i) + surf_lsm_h(0)%z0q(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h(0)%end_index(j,i)
-                         z0q_av(j,i) = z0q_av(j,i) + surf_usm_h(0)%z0q(m)
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDIF
+             DO  i = nxl-1, nxr+1
+                DO  j = nys-1, nyn+1
+                   DO  k = nzb, nzt+1
+                      w_av(k,j,i) = w_av(k,j,i) + w(k,j,i)
+                   ENDDO
+                ENDDO
+             ENDDO
 
           CASE DEFAULT
-
-!--          In case of urban surface variables it should be always checked if respective arrays are
-!--          allocated, at least in case of a restart run, as averaged usm arrays are not read from
-!--          file at the moment.
-             IF ( urban_surface )  THEN
-                CALL usm_3d_data_averaging( 'allocate', trimvar )
-             ENDIF
-
-!
-!--          Summing up data from all other modules
-             CALL module_interface_3d_data_averaging( 'sum', trimvar )
-
+!
+!--          User-defined quantity
+             CALL user_3d_data_averaging( 'sum', doav(ii) )
 
        END SELECT
@@ -1003,5 +379,5 @@
     ENDDO
 
-    CALL cpu_log( log_point(34), 'sum_up_3d_data', 'stop' )
+    CALL cpu_log (log_point(34),'sum_up_3d_data','stop','nobarrier')
 
 
